#'@export
lambdaGIC=function(y,x, tau, w, grid=seq(0, nrow(x)/20, length.out=nrow(x)/4), tol=1e-10){
  require(quantreg);
  pp=ncol(x);                           # Dimensionality
  nn=nrow(x);                           # sample size
  len=length(grid);                     # grid length

  lam=grid;

  bic=rep(0,len);
  
  for(i in 1:len){
    ka=lam[i];
    tmpfit=matrix(0, length(tau),pp);                            # tmp fitting
    testerr=rep(0,length(tau));
    for(s in 1:length(tau)){
      tmpfit[s,]=coef(rq(y~0+x,method="lasso",tau=tau[s],lambda=ka*w[s,]));
      tmpfit[s,]=tmpfit[s,]*(abs(tmpfit[s,])>=tol);
      err=y-x%*%tmpfit[s,];                                 # get the residuals
      testerr[s]=mean((err>0)*tau[s]*err-(1-tau[s])*(err<0)*err); # compute hat(sigma)(tau)
    }    
    bm=apply(abs(tmpfit),2,max);
    bic[i]=mean(log(testerr))+log(pp)*log(log(nn))/nn*sum(abs(bm[-1])>tol);                 # calculate BIC
    if(sum(abs(bm[-1]))>=nn/2) {bic[i]=1e+10;}
  }
  step.bic=which.min(bic);   
  return(lam[step.bic]);

}